﻿/*
	Vehicle Respawn Script by JoeJoe [ver 1.0090313]
	
	Place the vehicle_respawn.sqf in your mission folder and in the init of the vehicle write this:
	
	nul = [this, 15,60] execVM "vehicle_respawn.sqf";
	
	Parameter:
	1. Name of the Vehicle
	2. Respawntime if destroyed
	3. Respawntime if abandoned
	
	Known Issues:
	- Strange behaviour is vehicle is set under Buildings (e.g. Fuelstation) or is set on sloping terrain [the vehicle spawns with a few meters offset]
	- Not tested much in MP, should work on Dedicated Servers
*/


_vehicle = _this select 0;
_respawnDelay = _this select 1;
_abandonedDelay = _this select 2;

_loopCondition = true;
_vehicleType = typeOf _vehicle;
_vehicleDirection = getDir _vehicle;
_vehicleInitPostion = getPos _vehicle;
_abandonedTimer = 0;

while ({(_loopCondition) && (isServer)}) do {

	sleep 1;

	if(alive _vehicle) then {
	
		if(count crew _vehicle == 0) then {
		
			_vehicleCurrentPosition = getPos _vehicle;
			
			_result = (_vehicleCurrentPosition select 0) - (_vehicleInitPostion select 0);
			
			_result2 = (_vehicleCurrentPosition select 1) - (_vehicleCurrentPosition select 1);
			
			_result = _result + _result2;
			
			if((_result > 2) or (_result < -2)) then {
			
				_abandonedTimer = _abandonedTimer + 1;

				if(_abandonedTimer == _abandonedDelay) then {
				
					deleteVehicle _vehicle;
			
					sleep 0.5;
					
					_vehicle = _vehicleType createVehicle _vehicleInitPostion;
					
					_vehicle setDir _vehicleDirection;
					
					_commandString = format ["temp = [this, %1, %2]execVM ""scripts\vehicle_respawn.sqf"";", _respawnDelay, _abandonedDelay];
					
					_vehicle setVehicleInit _commandString;
					
					deleteMarker _marker;
					
					_loopCondition = false;
					
					processInitCommands;
				};
			}
		}
		else {
		
			_abandonedTimer = 0;
			
		};
	}
	else {
		
		sleep _respawnDelay;
		
		deleteVehicle _vehicle;
		
		sleep 0.5;
		
		_vehicle = _vehicleType createVehicle _vehicleInitPostion;
		
		_vehicle setDir _vehicleDirection;
		
		_commandString = format ["temp = [this, %1, %2]execVM ""scripts\vehicle_respawn.sqf"";", _respawnDelay, _abandonedDelay];
		
		_vehicle setVehicleInit _commandString;
		
		deleteMarker _marker;
		
		_loopCondition = false;
		
		processInitCommands;
	}
	
}